<html>
 <head>
	<meta charset="utf-8">
    <title>Projet</title>
    <style>canvas { width: 100%; height: 100% }</style>
		<script src="../node_modules/three/build/three.js"></script>
		<script src="../node_modules/three/examples/js/libs/dat.gui.min.js"></script>
		<script src="../node_modules/three/examples/js/controls/OrbitControls.js"></script>

		<script src="../node_modules/three/examples/js/loaders/OBJLoader.js"></script>
  </head>
  <body>

	<script id="vertexShader" type="x-shader/x-vertex">
		            varying vec3 vcolor;
		            attribute vec3 color;
		void main()
		{	
			vcolor=color;
			gl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );
		}
		
	</script>
	<script id="fragmentShader" type="x-shader/x-fragment">
		varying vec3 vcolor;
		void main()
		{
		
			gl_FragColor =vec4(vcolor,1.0);
		}
	</script>

    <script>
	
	// Global Variables

	//GUI initialisé dans la fonction INIT
	var gui = new dat.GUI();
	var start_time; //va contenir la valeur du temps au début
	var control_dist; //contrôleur gui de distance
	var control_tour; //contrôleur gui des tours
	var control_time; //contrôleur gui du temps écoulé depuis le début
	var control_speed; //contrôleur gui de la varibale de vitesse

	/* parametre de gameplay */
	var vitesse = 0;
	var deceleration_naturel = 0.02;
	var acceleration = 0.015;
	var frein = 0.07; //taux de freinage
	var vitesse_max = 1.3;//vitesse max en marche avant
	var vitesse_min = -0.5;//vitesse max en marche arrière
	var boost_time = 500; //0.5sec
	var boost_date; //date du passage sur la zone de boost
	var boost_effect = 0.5;
	var boost_patern_size = 4;
	var boost_patern_nb = 3;
	var boost_partern_color = new THREE.Color(1.0,0.01,0.03);

	/*parametre multijoueur */
	//var server_addr = "http://127.0.0.1:8000"; //addr du serv multi joueur
	var server_addr = "http://192.168.1.68:8000";
	var id; //id que va nous attribuer le serv
	var player_list; //la liste des joueurs tenu à jour (JSON)
	var player_model_list = []; //liste des modele3d des joueurs


	var key_list = {}; //liste des touches encore push

	var scene, camera, renderer;

	var player;
	var FP=false; // To determine if the the camera is first person or not, boolean
	var groundGeo;
	var gsize=50;

	var zSpeed=0.75;
	var xSpeed=0.25;

	var UNITWIDTH = gsize/10; // Width of a cubes in the maze
	var UNITHEIGHT = gsize/10; // Height of the cubes in the maze
		
	init();

	createGround();

	animate();

	function init() {

		scene = new THREE.Scene();

		scene.fog = new THREE.FogExp2(0xcccccc, 0.0015);

		camera = new THREE.PerspectiveCamera( 45, window.innerWidth/window.innerHeight, 0.1, 1000 );
		renderer = new THREE.WebGLRenderer({ antialias: true });
		renderer.setClearColor(scene.fog.color);

		renderer.shadowMap.enabled = true;

		renderer.setSize( window.innerWidth, window.innerHeight );
		document.body.appendChild( renderer.domElement );
		
		player = new THREE.Object3D();
		var box1_geometry = new THREE.BoxGeometry(2,2,5);
		var box1_material = new THREE.MeshBasicMaterial( { color: 0xf50505 } );
		var box = new THREE.Mesh( box1_geometry, box1_material );
		box.position.y = 1.25;
		player.add(box);
		var roue_geometry = new THREE.CylinderGeometry(0.5,0.5,0.2);
		var roue_material = new THREE.MeshBasicMaterial( { color: 0x050505 } );
		var roue1 = new THREE.Mesh( roue_geometry, roue_material );
		roue1.position.x = -0.9;
		roue1.position.z = -2.25;
		roue1.rotation.z = THREE.Math.degToRad(90);
		var roue2 = new THREE.Mesh( roue_geometry, roue_material );
		roue2.position.x = 0.9;
		roue2.position.z = -2.25;
		roue2.rotation.z = THREE.Math.degToRad(90);	
		var roue3 = new THREE.Mesh( roue_geometry, roue_material );
		roue3.position.x = -0.9;
		roue3.position.z = 2.25;
		roue3.rotation.z = THREE.Math.degToRad(90);
		var roue4 = new THREE.Mesh( roue_geometry, roue_material );
		roue4.position.x = 0.9;
		roue4.position.z = 2.25;
		roue4.rotation.z = THREE.Math.degToRad(90);
		player.add(roue1);
		player.add(roue2);
		player.add(roue3);
		player.add(roue4);
		

		scene.add( player );

		//calcul du déplacement
		futur_player = new THREE.Object3D();
		scene.add(futur_player);
			
		player.position.x = -40;
		player.position.z = 10;
		player.position.y = 0.5;

		/*
		//grille
		var gridHelper = new THREE.GridHelper( 2*gsize, 80, 0x0000ff, 0x808080 );	
		scene.add( gridHelper );
		*/

		camera.position.y = 10;
		camera.position.z = 50;
		player.add(camera);
		
		addLights();

		//event gestion des touches push pour la gestion des déplacements dans animate
		document.addEventListener("keydown", onDocumentKeyDown, false);
		document.addEventListener("keyup", onDocumentKeyUp, false);

		//GUI
		var init_data = {distance: 0, tour: 'start', temps: 'start', vitesse: 'float'};
		//ajoute la distance parcouru a GUI
		control_dist = gui.add(init_data, 'distance').listen();
		control_tour = gui.add(init_data, 'tour').listen();
		control_time = gui.add(init_data, 'temps').listen();
		start_time = Date.now();
		control_speed = gui.add(init_data, 'vitesse').listen();


		//demande une id au serv 
		var xhr = new XMLHttpRequest();
		xhr.open('GET', server_addr, false);
		try {
			xhr.send(null);
		}catch(exception) {//pour éviter que les erreurs de requêtes ne bloque tout le programme
		  	console.log('There was a network error.');
		}
		
		//on extrait l'ID du joueur de la requête
		reponse =  JSON.parse(xhr.response);
		id = reponse.yourId;
	
		update_position(true);//on lance une requête synchrone pour remplire le tableau de joueurs
		update_position(false);//on lance la routine de mise à jour des positions serveur
	}

	function createGround() {
		// Create ground geometry and material

		//create a triangular geometry
		groundGeo = new THREE.Geometry();

		var i=0;
		var j=0;
		var k;

		var posx,posy;
		posx=-gsize;
		posy=-gsize;

		for(k=0;k<2*gsize/UNITWIDTH;k++){
			for(i=0;i<2*gsize/UNITWIDTH;i++){

				// Determine the Color to put in the Grid
				var c;
				if(i>=2*gsize/UNITWIDTH/10*2 && i<2*gsize/UNITWIDTH/10*8 && k>=2*gsize/UNITWIDTH/10*2 && k<2*gsize/UNITWIDTH/10*8){//carré au centre 
					//dans le cas d'un carré bleu
					c=new THREE.Color(0.0,0.0,1.0)
				 //Dans le cas d'un damier
				}else if(i<1 || k<1 || i>=2*gsize/UNITWIDTH-1 || k>=2*gsize/UNITWIDTH-1){
					c=new THREE.Color(0.1,1.0,0.1);
				
				}else if((i+k)%2==0){
					c=new THREE.Color(0.0,0.05,0.05);
				}else{
					c=new THREE.Color(0.0,0.0,0.0);
				}

				// Draw the First Triangle with the color
				groundGeo.vertices.push(
					new THREE.Vector3( posx,  0, posy ), 
					new THREE.Vector3( posx, 0, posy+UNITWIDTH ),
					new THREE.Vector3(  posx+UNITWIDTH, 0, posy )
				);

				var face = new THREE.Face3( j, j+1, j+2);
				face.vertexColors[0]=c;
				face.vertexColors[1]=c;
				face.vertexColors[2]=c;
				
				//add the face to the geometry's faces array
				groundGeo.faces.push( face );

				// Draw the Second Triangle with the same color
				groundGeo.vertices.push(
					new THREE.Vector3(  posx+UNITWIDTH, 0, posy),
					new THREE.Vector3( posx, 0, posy+UNITWIDTH ),
					new THREE.Vector3(  posx+UNITWIDTH, 0, posy+UNITWIDTH )
				);
				var face2 = new THREE.Face3( j+3, j+4, j+5);

				face2.vertexColors[0]=c;
				face2.vertexColors[1]=c;
				face2.vertexColors[2]=c;

				//add the face to the geometry's faces array
				groundGeo.faces.push( face2);

				posx+=UNITWIDTH;
				j+=6;
			}
			posy+=UNITWIDTH;
			posx=-gsize;
		}

		//the face normals and vertex normals can be calculated automatically
		groundGeo.computeFaceNormals();
		groundGeo.computeVertexNormals();



		var groundMat = new THREE.ShaderMaterial( {
                    vertexShader: document.getElementById( 'vertexShader' ).textContent,
                    fragmentShader: document.getElementById( 'fragmentShader' ).textContent
                });
		var ground = new THREE.Mesh(groundGeo,groundMat);
		scene.add(ground);

		/**ligne de départ**/
		var start_line_geo = new THREE.Geometry();
		var c_blanc = new THREE.Color(1.0,1.0,1.0);
		for(var i=0;i<2*gsize/10*2-UNITWIDTH;i++){
			var v1,v2,v3;
			var v4,v5,v6;
			var f1,f2;
			if(i%2 == 0){//si paire on fait un carré blanc en haut
				v1 = new THREE.Vector3(i-gsize+UNITWIDTH,0.01,0);
				v2 = new THREE.Vector3(i-gsize+UNITWIDTH,0.01,1);
				v3 = new THREE.Vector3(i-gsize+UNITWIDTH+1,0.01,1);
				v4 = new THREE.Vector3(i-gsize+UNITWIDTH+1,0.01,0);
				f1 = new THREE.Face3(4*i,4*i+1,4*i+2);
				f2 = new THREE.Face3(4*i,4*i+2,4*i+3);	
			}else{//si impaire on fait un carré blanc en bas
				v1 = new THREE.Vector3(i-gsize+UNITWIDTH,0.01,0);
				v4 = new THREE.Vector3(i-gsize+UNITWIDTH+1,0.01,-1);
				v2 = new THREE.Vector3(i-gsize+UNITWIDTH,0.01,-1);
				v3 = new THREE.Vector3(i-gsize+UNITWIDTH+1,0.01,0);
				f1 = new THREE.Face3(4*i+1,4*i,4*i+3);
				f2 = new THREE.Face3(4*i,4*i+2,4*i+3);	
			}
			start_line_geo.vertices.push(v1,v2,v3,v4);

			f1.vertexColors[0]=c_blanc;
			f1.vertexColors[1]=c_blanc;
			f1.vertexColors[2]=c_blanc;
			f2.vertexColors[0]=c_blanc;
			f2.vertexColors[1]=c_blanc;
			f2.vertexColors[2]=c_blanc;
			start_line_geo.faces.push(f1);
			start_line_geo.faces.push(f2);
		}
		var start_line = new THREE.Mesh(start_line_geo,groundMat);
		scene.add(start_line);

		/* zone de boost */
		var patern_geo = new THREE.Geometry();
		patern_geo.vertices.push(
			new THREE.Vector3(-boost_patern_size/2, 0, 0),//1: -1,0
			new THREE.Vector3(0, 0, -boost_patern_size/2),//2: 0,-1
			new THREE.Vector3(-boost_patern_size, 0, -boost_patern_size/2),//3: -2,-1
			new THREE.Vector3(-boost_patern_size/2, 0, -boost_patern_size/2),//4: -1,-1
			new THREE.Vector3(0, 0, -boost_patern_size),//5: 0,-2
			new THREE.Vector3(-boost_patern_size, 0, -boost_patern_size)//6: -2,-2
		);
		//on ajoute les 3 triangles
		var f1 = new THREE.Face3( 0,1,2);
		var f2 = new THREE.Face3( 1,4,3);
		var f3 = new THREE.Face3( 2,3,5);
		//on ajoute les couleurs à chaque points
		f1.vertexColors = [boost_partern_color, boost_partern_color, boost_partern_color];
		f2.vertexColors = [boost_partern_color, boost_partern_color, boost_partern_color];
		f3.vertexColors = [boost_partern_color, boost_partern_color, boost_partern_color];
		patern_geo.faces.push(f1, f2, f3);
		patern_mat = new THREE.ShaderMaterial( {
		            	vertexShader: document.getElementById( 'vertexShader' ).textContent,
		            	fragmentShader: document.getElementById( 'fragmentShader' ).textContent
		        	});
		patern = new THREE.Mesh(patern_geo, patern_mat);
		for(var i=0; i<boost_patern_nb; i++){
			var patern_cloned = patern.clone();
			patern_cloned.position.x = gsize-2*gsize/10*2+boost_patern_size;
			patern_cloned.position.z = gsize-2*gsize/10*7+(i+1)*boost_patern_size;
			patern_cloned.position.y = 0.001;
			scene.add(patern_cloned);
		}
	

	}


	function animate() {
		show_other_player();
		deplacement();//mise à jour des déplacements / rotations
		control_time.setValue(Math.round((Date.now()-start_time)/10)/100);
		requestAnimationFrame( animate );
		renderer.render( scene, camera );

	}

	function addLights() {
		var lightOne = new THREE.DirectionalLight(0xffffff);
		lightOne.position.set(1, 1, 1);
		scene.add(lightOne);

		// Add a second light with half the intensity
		var lightTwo = new THREE.DirectionalLight(0xffffff, .5);
		lightTwo.position.set(1, -1, -1);
		scene.add(lightTwo);
	}
	
	function deplacement(){
		var r_acceleration = acceleration;
		if(	//si dans la zone verte
			player.position.x<-gsize+UNITWIDTH ||
			player.position.z<-gsize+UNITWIDTH ||
			player.position.x>=gsize-UNITWIDTH ||
			player.position.z>=gsize-UNITWIDTH
		){
			r_acceleration = acceleration/2;
		}
		// UP accélération (ou frein si marche arrière)
		if (key_list[38]) {
			if(vitesse >= 0){//si on est en marche avant ou à l'arret
				vitesse = Math.min(vitesse+r_acceleration,vitesse_max);
			}else if(!key_list[40]){//si marche arrière et pas d'accélération
				vitesse = Math.min(0, vitesse+frein);
			}	
		}

		// DOWN décélération (ou accélération si marche arrière)
		if (key_list[40]) {
			if(vitesse <= 0){//si marche arrière ou à l'arret
				vitesse = Math.max(vitesse_min, vitesse-r_acceleration/2);
			}else if(!key_list[38]){//si marche avant et pas d'accélération
				vitesse = Math.max(0, vitesse-frein);
			}
		} 

		if(!key_list[38] && !key_list[40]){//si on ne fait rien
			//décéleration naturel	
			if(vitesse > 0){//si marche avant
				vitesse = Math.max(0, vitesse-deceleration_naturel);//pour éviter de passé en négatif
			}else if(vitesse < 0){//si marche arrière
				vitesse = Math.min(0, vitesse+deceleration_naturel);//pour éviter de passé en négatif		
			}
		}

		//première éstimation de la position pour le boost
		futur_player.position.x = player.position.x;
		futur_player.position.z = player.position.z;
		futur_player.rotation.y = player.rotation.y;
		futur_player.translateZ(-vitesse);
		if(	//dans la zone du boost
			player.position.x < gsize-2*gsize/10*2+boost_patern_size &&
			player.position.x > gsize-2*gsize/10*2 &&
			player.position.z < gsize-2*gsize/10*7+(boost_patern_nb+1)*boost_patern_size &&
			player.position.z > gsize-2*gsize/10*7+boost_patern_size &&
			//dans le bon sens
			player.position.z < futur_player.position.z
		){
			boost_date = Date.now();
		}

		var r_vitesse = vitesse;		

		if(boost_date >= Date.now()-boost_time){//si le boost fait éffet
			r_vitesse = r_vitesse + boost_effect;
		}	

		if(	//si dans la zone verte
			player.position.x<-gsize+UNITWIDTH ||
			player.position.z<-gsize+UNITWIDTH ||
			player.position.x>=gsize-UNITWIDTH ||
			player.position.z>=gsize-UNITWIDTH
		){
			r_vitesse = r_vitesse/2;	//vitesse diminué		
		}
		control_speed.setValue(Math.round(r_vitesse*100)/100);
		//on applique la vitesse
		if(r_vitesse != null && r_vitesse != 0){
			futur_player.position.x = player.position.x;
			futur_player.position.z = player.position.z;
			futur_player.rotation.y = player.rotation.y;
			futur_player.translateZ(-r_vitesse);
			if(!(/*position hors du damier */
				futur_player.position.z < -gsize ||
				futur_player.position.x > gsize || 
				futur_player.position.z > gsize || 
				futur_player.position.x < -gsize || 
				/*position dans la zone bleue*/
				(futur_player.position.z<gsize-2*gsize/10*2 &&
				 futur_player.position.z>gsize-2*gsize/10*8 &&
				 futur_player.position.x<gsize-2*gsize/10*2 &&
				 futur_player.position.x>gsize-2*gsize/10*8))
			){//si position permise
				if(
					player.position.x < 0/*position comprise dans [-50, -30] */
					&& player.position.z > 0/* le joueur n'a pas passé la ligne de départ */
					&& futur_player.position.z < 0/* il va passer la ligne de départ*/
				){
					tour = control_tour.getValue();
					if(tour == 'start'){//si la partie n'a pas encore commencé
						tour = 0;
					}else{
						tour++;
					}
					control_tour.setValue(tour);//mise à jour du nombre de tour
				}else if(
					player.position.x < -gsize*2/10*2/*position comprise dans [-50, -30] */
					&& player.position.z < 0
					&& futur_player.position.z > 0
				){//la ligne est passé dans l'autre sens!!
					tour = control_tour.getValue();
					if(tour == 'start' || tour == 0){//si la partie n'a pas encore commencé
						tour = 'start';
					}else{
						tour--;
					}
					control_tour.setValue(tour);//mise à jour du nombre de tour
				}
				player.translateZ(-r_vitesse);
			}else{//on est contre un objet, notre vitesse passe à 0
				vitesse = 0;
			}
		}
		if(r_vitesse > 0){
			control_dist.setValue(control_dist.getValue()+r_vitesse);//mise à jour de la distance parcouru
		}
		// RIGHT
		if (key_list[39]) {
				player.rotation.y -= xSpeed/6;
		} 
		// LEFT
		if (key_list[37]) {UNITWIDTH
				player.rotation.y += xSpeed/6;
		}

	 }
	function onDocumentKeyUp(event){
		key_list[event.keyCode] = false;//on met à jour la liste des touche maintenu
		
	}

	function onDocumentKeyDown(event) {
		key_list[event.keyCode] = true;//on met à jour la liste des touche maintenu
		// A, camera in First Person Mode or Behind
		//ici pour éviter de changer trop vite de mode dans le animate
		if (key_list[65]) {
			if(FP)
			// CAMERA BEHIND
			{
				camera.position.z = 50;
				camera.position.y = 10;
			}
			// FPS CAMERA
			else{
				camera.position.z = -2;
				camera.position.y = 3;
			}
			FP=!FP;
		}
		
	}

	function update_position(start){
		var xhr = new XMLHttpRequest();
		xhr.open('POST', server_addr, !start);//asynchrone pour éviter de bloquer le programme
		xhr.onreadystatechange = function() {//quand la requête est fini
			 if (this.readyState === XMLHttpRequest.DONE && this.status === 200) {
				player_list =  JSON.parse(xhr.response);//mise à jour de la liste des utilisateurs		
				if(!start){
					update_position();//une fois la requête terminé et traité, on en relance une	
				}		
			}
		}
		xhr.send(JSON.stringify({"id": id, "x": player.position.x, "y":player.rotation.y, "z":player.position.z}));//paramètre a envoyer au serveur	
	}

	function show_other_player(){
		//on supprime les modeles de tout les joueurs
		for( i in player_model_list){
			scene.remove(player_model_list[i]);
		}
		//on ajoute de nouveaux modeles pour chauqe joueurs transmis par le serveur
		player_model_list = [];
		for (e in player_list["users"]){
			if(e != id){//on affiche qu'une fois notre voiture
				player_model_list[e] = player.clone();//on fait un clone de notre voiture
				player_model_list[e].position.x = player_list["users"][e]["x"];
				player_model_list[e].rotation.y = player_list["users"][e]["y"];
				player_model_list[e].position.z = player_list["users"][e]["z"];
				scene.add(player_model_list[e]);
			}				
		}	
	}
    </script>
  </body>
</html>


